#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.10 $
#
#   last change: $Author: kz $ $Date: 2006/07/19 13:14:22 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

EXTERNAL_WARNINGS_NOT_ERRORS := TRUE

PRJ=..$/..
PRJNAME=binfilter
TARGET=bf_lng

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

ENABLE_EXCEPTIONS=TRUE

#----- Settings ---------------------------------------------------------

.INCLUDE : settings.mk
INC+= -I$(PRJ)$/inc$/bf_linguistic
# --- Files --------------------------------------------------------

EXCEPTIONSFILES=\
		$(SLO)$/linguistic_dicimp.obj\
		$(SLO)$/linguistic_dlistimp.obj\
		$(SLO)$/linguistic_hyphdsp.obj\
		$(SLO)$/linguistic_lngopt.obj\
		$(SLO)$/linguistic_lngreg.obj\
		$(SLO)$/linguistic_lngsvcmgr.obj\
		$(SLO)$/linguistic_misc.obj\
		$(SLO)$/linguistic_spelldsp.obj\
		$(SLO)$/linguistic_thesdsp.obj

SLOFILES = \
		$(SLO)$/linguistic_dicimp.obj\
		$(SLO)$/linguistic_dlistimp.obj\
		$(SLO)$/linguistic_hyphdsp.obj\
		$(SLO)$/linguistic_hyphdta.obj\
		$(SLO)$/linguistic_iprcache.obj\
		$(SLO)$/linguistic_lngopt.obj\
		$(SLO)$/linguistic_lngsvcmgr.obj\
		$(SLO)$/linguistic_misc.obj\
		$(SLO)$/linguistic_spelldsp.obj\
		$(SLO)$/linguistic_spelldta.obj\
		$(SLO)$/linguistic_thesdsp.obj\
		$(SLO)$/linguistic_lngreg.obj

SHL1TARGET= $(TARGET)$(UPD)$(DLLPOSTFIX)

SHL1STDLIBS= \
		$(CPPULIB) 	 \
		$(CPPUHELPERLIB) 	 \
		$(UNOLIB)		\
		$(VOSLIB)		\
		$(TOOLSLIB)		\
		$(I18NISOLANGLIB) \
		$(SVTOOLLIB)	\
		$(SVLLIB)		\
		$(VCLLIB)		\
		$(BFSVXLIB)		\
		$(LEGACYSMGRLIB)	\
		$(SALLIB)		\
		$(UCBHELPERLIB)	\
		$(UNOTOOLSLIB)
		
# build DLL
SHL1LIBS=		$(SLB)$/$(TARGET).lib
SHL1DEPN=		$(SLB)$/$(TARGET).lib
SHL1DEF=		$(MISC)$/$(SHL1TARGET).def
#SHL1VERSIONMAP= $(TARGET).map
SHL1IMPLIB= bf_ilng

# build DEF file
DEF1NAME	=$(SHL1TARGET)

.IF "$(GUI)"=="WNT"
DEF1EXPORT1 = component_writeInfo
DEF1EXPORT2 = component_getFactory
DEF1EXPORT3 = component_getImplementationEnvironment
.ELSE
DEF1EXPORT1 = _component_writeInfo
DEF1EXPORT2 = _component_getFactory
DEF1EXPORT3 = _component_getImplementationEnvironment
.ENDIF

# --- Targets ------------------------------------------------------

.INCLUDE : target.mk
