/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_csvgrid.cxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 15:43:51 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifdef PCH
#endif
#pragma hdrstop

// ============================================================================


#include <algorithm>


#ifndef SC_SCMOD_HXX
#include "scmod.hxx"
#endif
#ifndef SC_ASCIIOPT_HXX
#include "asciiopt.hxx"
#endif


// *** edit engine ***
#include "scitems.hxx"
#define ITEMID_FIELD EE_FEATURE_FIELD


#ifndef SC_EDITUTIL_HXX
#include "editutil.hxx"
#endif
namespace binfilter {
// *** edit engine ***


// ============================================================================

/*M*/ struct Func_SetType
/*M*/ {
/*M*/     sal_Int32                   mnType;
/*M*/     inline                      Func_SetType( sal_Int32 nType ) : mnType( nType ) {}
/*M*/     inline void                 operator()( ScCsvColState& rState ) { rState.mnType = mnType; }
/*M*/ };

/*M*/ struct Func_Select
/*M*/ {
/*M*/     bool                        mbSelect;
/*M*/     inline                      Func_Select( bool bSelect ) : mbSelect( bSelect ) {}
/*M*/     inline void                 operator()( ScCsvColState& rState ) { rState.Select( mbSelect ); }
/*M*/ };


// ============================================================================

/*M*/ ScCsvGrid::ScCsvGrid( ScCsvControl& rParent ) :
/*M*/     ScCsvControl( rParent ),
/*M*/     mrColorConfig( SC_MOD()->GetColorConfig() ),
/*M*/     mpEditEngine( new ScEditEngineDefaulter( EditEngine::CreatePool(), TRUE ) ),
/*M*/     maHeaderFont( GetFont() ),
/*M*/     maColStates( 1 ),
/*M*/     maTypeNames( 1 ),
/*N*/     mnFirstImpLine( 0 ),
/*M*/     mnRecentSelCol( CSV_COLUMN_INVALID )
/*M*/ {
/*M*/     DBG_BF_ASSERT(0, "STRIP"); //STRIP001 mpEditEngine->SetRefDevice( &maBackgrDev );
/*M*/ }

/*N*/ ScCsvGrid::~ScCsvGrid()
/*N*/ {
/*?*/ DBG_BF_ASSERT(0, "STRIP"); //STRIP001     EndListening( mrColorConfig );
/*N*/ }


// common grid handling -------------------------------------------------------










// split handling -------------------------------------------------------------









// columns/column types -------------------------------------------------------






















// selection handling ---------------------------------------------------------













// cell contents --------------------------------------------------------------





// event handling -------------------------------------------------------------











// painting -------------------------------------------------------------------














// accessibility ==============================================================



// ============================================================================

}
