/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_undodat.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 16:59:17 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

#ifdef PCH
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------


#include "undodat.hxx"
#include "tabvwsh.hxx"
#include "dbcolect.hxx"
#include "globstr.hrc"
#include "bf_sc.hrc"
namespace binfilter {

// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


//
//		Outline-Gruppen ein- oder ausblenden
//








//
//		Outline-Gruppen erzeugen oder loeschen
//








//
//		Outline-Ebene auswaehlen
//








//
//		Outline ueber Blockmarken ein- oder ausblenden
//








//
//		alle Outlines loeschen
//








//
//		Auto-Outline
//








//
//		Zwischenergebnisse
//








//
//		Sortieren
//








//
//		Filtern
//








//
//		Datenbankbereiche aendern (Dialog)
//

/*N*/ ScUndoDBData::ScUndoDBData( ScDocShell* pNewDocShell,
/*N*/ 							ScDBCollection* pNewUndoColl, ScDBCollection* pNewRedoColl ) :
/*N*/ 	ScSimpleUndo( pNewDocShell ),
/*N*/ 	pUndoColl( pNewUndoColl ),
/*N*/ 	pRedoColl( pNewRedoColl )
/*N*/ {
/*N*/ }

/*N*/ __EXPORT ScUndoDBData::~ScUndoDBData()
/*N*/ {
/*N*/ 	delete pUndoColl;
/*N*/ 	delete pRedoColl;
/*N*/ }

/*N*/ String __EXPORT ScUndoDBData::GetComment() const
/*N*/ {	// "Datenbankbereiche aendern";
/*N*/ 	return ScGlobal::GetRscString( STR_UNDO_DBDATA );
/*N*/ }




/*N*/ BOOL __EXPORT ScUndoDBData::CanRepeat(SfxRepeatTarget& rTarget) const
/*N*/ {
/*N*/ 	return FALSE;						// geht nicht
/*N*/ }

//
//		Import
//








//
//		Operationen wiederholen
//








//
//		Pivot-Tabellen
//









//
//		data pilot
//









//
//		Konsolidieren
//









//
//		Quell-Daten von Chart aendern
//


/*N*/ ScUndoChartData::ScUndoChartData( ScDocShell* pNewDocShell, const String& rName,
/*N*/ 									const ScRange& rNew, BOOL bColHdr, BOOL bRowHdr,
/*N*/ 									BOOL bAdd ) :
/*N*/ 	ScSimpleUndo( pNewDocShell ),
/*N*/ 	aChartName( rName ),
/*N*/ 	bNewColHeaders( bColHdr ),
/*N*/ 	bNewRowHeaders( bRowHdr ),
/*N*/ 	bAddRange( bAdd )
/*N*/ {
/*?*/ 	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 aNewRangeListRef = new ScRangeList;
/*N*/ }

/*N*/ ScUndoChartData::ScUndoChartData( ScDocShell* pNewDocShell, const String& rName,
/*N*/ 									const ScRangeListRef& rNew, BOOL bColHdr, BOOL bRowHdr,
/*N*/ 									BOOL bAdd ) :
/*N*/ 	ScSimpleUndo( pNewDocShell ),
/*N*/ 	aChartName( rName ),
/*N*/ 	aNewRangeListRef( rNew ),
/*N*/ 	bNewColHeaders( bColHdr ),
/*N*/ 	bNewRowHeaders( bRowHdr ),
/*N*/ 	bAddRange( bAdd )
/*N*/ {
/*?*/ 	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 Init();
/*N*/ }

/*N*/ __EXPORT ScUndoChartData::~ScUndoChartData()
/*N*/ {
/*N*/ }











}
