/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_tabvwsh.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 17:16:11 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifdef PCH
#endif

#pragma hdrstop

//------------------------------------------------------------------
// INCLUDE ---------------------------------------------------------------

#include <bf_svx/galbrws.hxx>
#include <bf_svx/imapdlg.hxx>
#include <bf_offmgr/sbasltid.hrc>
#include <bf_sfx2/templdlg.hxx>
#include <bf_sfx2/app.hxx>

#include "tabvwsh.hxx"
#include "docsh.hxx"
#include "reffact.hxx"
#include "scresid.hxx"
#include "dwfunctr.hxx"
#include "bf_sc.hrc"       // -> SID_TOOL_xxx
#include "drawattr.hxx" // -> SvxDrawToolItem

namespace binfilter {

#define ScTabViewShell
#include "scslots.hxx"

#define	SearchSettings

/*N*/ TYPEINIT2(ScTabViewShell,SfxViewShell,SfxListener);

/*N*/ SFX_IMPL_INTERFACE(ScTabViewShell,SfxViewShell,ScResId(SCSTR_TABVIEWSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS  | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								ScResId(RID_OBJECTBAR_TOOLS) );
/*N*/ 
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(FID_INPUTLINE_STATUS);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SfxTemplateDialogWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_CONTEXT_REGISTRATION(SID_NAVIGATOR);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScNameDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScSolverDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScPivotLayoutWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScTabOpDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScFilterDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScSpecialFilterDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScDbNameDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScConsolidateDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScChartDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScPrintAreasDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScCondFormatDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScColRowNameRangesDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScFormulaDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SvxIMapDlgChildWindow::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScFunctionChildWindow::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScFormulaDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScAcceptChgDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScHighlightChgDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(ScSimpleRefDlgWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SID_SEARCH_DLG);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SID_HYPERLINK_DIALOG);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(GalleryChildWindow::GetChildWindowId());
/*N*/ }

/*N*/ SFX_IMPL_VIEWFACTORY( ScTabViewShell, ScResId(STR_NONAME) )
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(ScDocShell);
/*N*/ }

//------------------------------------------------------------------


}
