/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_drbezob.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 18:40:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif

#pragma hdrstop


#include "res_bmp.hrc"
#include "glob.hrc"
#include "strings.hrc"

#include "docshell.hxx"
#include "viewshel.hxx"
#include "drawview.hxx"
#include "sdresid.hxx"
#include "drbezob.hxx"

/*************************************************************************
|*
|* Standardinterface deklarieren (Die Slotmap darf nicht leer sein)
|*
\************************************************************************/
namespace binfilter {

#define SdDrawBezierObjectBar

SFX_DECL_TYPE(13);

#include "sdslots.hxx"

/*N*/ SFX_IMPL_INTERFACE(SdDrawBezierObjectBar, SfxShell, SdResId(STR_BEZIEROBJECTBARSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_BEZIER_TOOLBOX) );
/*N*/ }

TYPEINIT1( SdDrawBezierObjectBar, SfxShell );

/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

/*N*/ SdDrawBezierObjectBar::SdDrawBezierObjectBar(SdViewShell* pSdViewShell,
/*N*/ 											 SdView* pSdView) :
/*N*/ 	SfxShell(pSdViewShell),
/*N*/ 	pView(pSdView),
/*N*/ 	pViewSh(pSdViewShell)
/*N*/ {
/*N*/ 	SdDrawDocShell* pDocShell = pViewSh->GetDocSh();
/*N*/ 	SetPool(&pDocShell->GetPool());
/*N*/ 	SetUndoManager(pDocShell->GetUndoManager());
/*N*/ 	SetRepeatTarget(pView);
/*N*/ 
/*N*/ 	SetHelpId( SD_IF_SDDRAWBEZIEROBJECTBAR );
/*N*/ }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ SdDrawBezierObjectBar::~SdDrawBezierObjectBar()
/*N*/ {
/*N*/ 	SetRepeatTarget(NULL);
/*N*/ }


/*************************************************************************
|*
|* Status der Attribut-Items
|*
\************************************************************************/



/*************************************************************************
|*
|* Bearbeitung der SfxRequests
|*
\************************************************************************/




}
