/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_drglueob.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:34:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SFXAPP_HXX
#include <bf_sfx2/app.hxx>
#endif

#pragma hdrstop

#include "res_bmp.hrc"
#include "glob.hrc"

#include "docshell.hxx"
#include "viewshel.hxx"
#include "drawview.hxx"
#include "drglueob.hxx"
#include "sdresid.hxx"
namespace binfilter {



/*************************************************************************
|*
|* Standardinterface deklarieren (Die Slotmap darf nicht leer sein)
|*
\************************************************************************/

#define ShellClass SdDrawGluePointsObjectBar

SFX_SLOTMAP(SdDrawGluePointsObjectBar)
{
			{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

/*N*/ SFX_IMPL_INTERFACE(SdDrawGluePointsObjectBar, SfxShell, SdResId(STR_GLUEPOINTSOBJECTBARSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_GLUEPOINTS_TOOLBOX) );
/*N*/ }

TYPEINIT1( SdDrawGluePointsObjectBar, SfxShell );


/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

/*N*/ SdDrawGluePointsObjectBar::SdDrawGluePointsObjectBar(SdViewShell* pSdViewShell,
/*N*/ 											 SdView* pSdView) :
/*N*/ 	SfxShell(pSdViewShell)
/*N*/ {
/*N*/ 	SdDrawDocShell* pDocShell = pSdViewShell->GetDocSh();
/*N*/ 	SetPool(&pDocShell->GetPool());
/*N*/ 	SetUndoManager(pDocShell->GetUndoManager());
/*N*/ 	SetRepeatTarget(pSdView);
/*N*/ 
/*N*/ 	SetHelpId( SD_IF_SDDRAWGLUEPOINTSOBJECTBAR );
/*N*/ }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ SdDrawGluePointsObjectBar::~SdDrawGluePointsObjectBar()
/*N*/ {
/*N*/ 	SetRepeatTarget(NULL);
/*N*/ }


}
