/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_drtxtob.cxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 18:40:47 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#define ITEMID_FRAMEDIR EE_PARA_WRITINGDIR

#ifndef _EEITEMID_HXX
#include <bf_svx/eeitemid.hxx>
#endif

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif

#ifndef _XDEF_HXX
#include <bf_svx/xdef.hxx>
#endif

#ifndef _SVX_FRMDIRITEM_HXX
#include <bf_svx/frmdiritem.hxx>
#endif

#pragma hdrstop


#include "app.hrc"
#include "glob.hrc"
#include "res_bmp.hrc"

#include "drtxtob.hxx"
#include "drawdoc.hxx"
#include "drviewsh.hxx"
#include "outlnvsh.hxx"
#include "sdresid.hxx"

#ifndef _SD_SDVIEW_HXX
#include "sdview.hxx"
#endif

/*************************************************************************
|*
|* Standardinterface deklarieren (Die Slotmap darf nicht leer sein, also
|* tragen wir etwas ein, was hier (hoffentlich) nie vorkommt).
|*
\************************************************************************/
namespace binfilter {

#define SdDrawTextObjectBar
#define FEATURE_DRAW_TEXT_OBJECTBAR		1L
#define FEATURE_GRAPHIC_TEXT_OBJECTBAR	2L

SFX_DECL_TYPE(13);

#include "sdslots.hxx"

/*N*/ SFX_IMPL_INTERFACE( SdDrawTextObjectBar, SfxShell, SdResId(STR_TEXTOBJECTBARSHELL) )
/*N*/ {
/*N*/ //    SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_DRAW_TEXT_TOOLBOX) );
/*N*/ 	SFX_FEATURED_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_DRAW_TEXT_TOOLBOX),
/*N*/ 										 FEATURE_DRAW_TEXT_OBJECTBAR );
/*N*/ 	SFX_FEATURED_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId(RID_GRAPHIC_TEXT_TOOLBOX),
/*N*/ 										 FEATURE_GRAPHIC_TEXT_OBJECTBAR );
/*N*/ }

TYPEINIT1( SdDrawTextObjectBar, SfxShell );

/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

/*N*/ SdDrawTextObjectBar::SdDrawTextObjectBar( SdViewShell* pSdViewSh,
/*N*/ 				SfxItemPool& rItemPool, SdView* pSdView ) :
/*N*/ 	SfxShell(pSdViewSh),
/*N*/ 	rPool( rItemPool ),
/*N*/ 	pViewShell( pSdViewSh ),
/*N*/ 	pView( pSdView )
/*N*/ {
/*N*/ 	SetPool(&rItemPool);
/*N*/ 
/*N*/ 	if (pSdViewSh->ISA(SdOutlineViewShell))
/*N*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 SfxUndoManager& rUndoMgr = ((SdOutlineView*)pSdView)->
/*N*/ 	}
/*N*/ 	else
/*N*/ 	{
/*N*/ 		SdDrawDocument* pDoc	  = pView->GetDoc();
/*N*/ 		SdDrawDocShell* pDocShell = pDoc->GetDocSh();
/*N*/ 		SfxUndoManager* pUndoMgr  = pDocShell->GetUndoManager();
/*N*/ 		SetUndoManager(pUndoMgr);
/*N*/ 		if ( pSdViewSh->ISA(SdDrawViewShell) )
/*N*/ 			SetRepeatTarget(pSdView);
/*N*/ 	}
/*N*/ 
/*N*/ 	SetName( String( RTL_CONSTASCII_USTRINGPARAM( "SdDrawTextObjectBar" )));
/*N*/ 
/*N*/ 	// SetHelpId( SD_IF_SDDRAWTEXTOBJECTBAR );
/*N*/ }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ SdDrawTextObjectBar::~SdDrawTextObjectBar()
/*N*/ {
/*N*/ 	SetRepeatTarget(NULL);
/*N*/ }

/*************************************************************************
|*
|* Status der Attribut-Items
|*
\************************************************************************/


/*************************************************************************
|*
|* Command event
|*
\************************************************************************/


/*************************************************************************
|*
|* Unterstuetzte Features erfragen
|*
\************************************************************************/




}
