/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_drvwshrg.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 18:44:08 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SFX_TEMPLDLG_HXX //autogen
#include <bf_sfx2/templdlg.hxx>
#endif

#include <bf_svx/fontwork.hxx>
#include <bf_svx/bmpmask.hxx>
#include <bf_svx/galbrws.hxx>
#include <bf_svx/imapdlg.hxx>
#include <bf_svx/colrctrl.hxx>

#ifndef _SVX_F3DCHILD_HXX //autogen
#include <bf_svx/f3dchild.hxx>
#endif

#include <bf_svx/svxids.hrc>
#include <bf_offmgr/hyprlink.hxx>

#ifndef _SVX_TAB_HYPERLINK_HXX
#include <bf_svx/hyperdlg.hxx>
#endif

#pragma hdrstop

#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
#include "glob.hrc"
#include "grdocsh.hxx"
#include "grviewsh.hxx"
#include "animobjs.hxx"
#include "prevchld.hxx"
#include "efctchld.hxx"
#include "slidchld.hxx"
//#include "3dchld.hxx"


namespace binfilter {

#define TABCONTROL_INITIAL_SIZE 	500

/*************************************************************************
|*
|* SFX-Slotmap und Standardinterface deklarieren
|*
\************************************************************************/

SFX_DECL_TYPE(13);

#define SdDrawViewShell
#include "sdslots.hxx"

/*N*/ SFX_IMPL_INTERFACE(SdDrawViewShell, SfxViewShell, SdResId(STR_DRAWVIEWSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_TOOLBOX));
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OPTIONS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_OPTIONS_TOOLBOX));
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_COMMONTASK | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_COMMONTASK_TOOLBOX));
/*N*/     SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION | SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT | SFX_VISIBILITY_VIEWER | SFX_VISIBILITY_READONLYDOC,
/*N*/             					SdResId(RID_DRAW_VIEWER_TOOLBOX) );
/*N*/ 	SFX_CHILDWINDOW_CONTEXT_REGISTRATION( SID_NAVIGATOR );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SfxTemplateDialogWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxFontWorkChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxColorChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SdAnimationChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SdPreviewChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SdEffectChildWindow::GetChildWindowId() );
/*N*/ 	//SFX_CHILDWINDOW_REGISTRATION( Sd3DChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( Svx3DChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SdSlideChangeChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxBmpMaskChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( GalleryChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxIMapDlgChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHyperlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SID_SEARCH_DLG );
/*N*/ }
/*N*/ 
/*N*/ SFX_IMPL_VIEWFACTORY(SdDrawViewShell, SdResId(STR_DEFAULTVIEW) )
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(SdDrawDocShell);
/*N*/ }

/*N*/ TYPEINIT1( SdDrawViewShell, SdViewShell );


// SdGraphicViewShell

#define SdGraphicViewShell
#include "sdgslots.hxx"

/*N*/ SFX_IMPL_INTERFACE(SdGraphicViewShell, SfxViewShell, SdResId(STR_DRAWVIEWSHELL)) //SOH...
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_GRAPHIC_TOOLBOX));
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OPTIONS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_GRAPHIC_OPTIONS_TOOLBOX));
/*N*/     SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION | SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT | SFX_VISIBILITY_VIEWER | SFX_VISIBILITY_READONLYDOC,
/*N*/             					SdResId(RID_GRAPHIC_VIEWER_TOOLBOX) );
	/*SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_COMMONTASK | SFX_VISIBILITY_STANDARD |
								SFX_VISIBILITY_SERVER,
 								SdResId(RID_DRAW_COMMONTASK_TOOLBOX));*/
/*N*/ 	SFX_CHILDWINDOW_CONTEXT_REGISTRATION( SID_NAVIGATOR );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SfxTemplateDialogWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxFontWorkChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxColorChildWindow::GetChildWindowId() );
/*N*/ 	//SFX_CHILDWINDOW_REGISTRATION( SdAnimationChildWindow::GetChildWindowId() );
/*N*/ 	/* ? */SFX_CHILDWINDOW_REGISTRATION( SdPreviewChildWindow::GetChildWindowId() );
/*N*/ 	//SFX_CHILDWINDOW_REGISTRATION( SdEffectChildWindow::GetChildWindowId() );
/*N*/ 	//SFX_CHILDWINDOW_REGISTRATION( SdSlideChangeChildWindow::GetChildWindowId() );
/*N*/ 	//SFX_CHILDWINDOW_REGISTRATION( Sd3DChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( Svx3DChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxBmpMaskChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( GalleryChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxIMapDlgChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHyperlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SID_SEARCH_DLG );
/*N*/ }

/*N*/ SFX_IMPL_VIEWFACTORY(SdGraphicViewShell, SdResId(STR_DEFAULTVIEW) )
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(SdGraphicDocShell);
/*N*/ }

/*N*/ TYPEINIT1( SdGraphicViewShell, SdDrawViewShell );


}
