/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_outlnvsh.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 18:45:07 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#include "app.hrc"
#define ITEMID_HYPERLINK    SID_HYPERLINK_SETLINK
#ifndef _SVX_DLG_HYPERLINK_HXX //autogen
#include <bf_offmgr/hyprlink.hxx>
#endif
#ifndef _SVX_TAB_HYPERLINK_HXX
#include <bf_svx/hyperdlg.hxx>
#endif

#ifndef _SVX_ZOOMITEM_HXX //autogen
#include <bf_svx/zoomitem.hxx>
#endif






#define ITEMID_FIELD    EE_FEATURE_FIELD
#ifndef _SFX_TEMPLDLG_HXX //autogen
#include <bf_sfx2/templdlg.hxx>
#endif
#ifndef _VIEWFAC_HXX //autogen
#include <bf_sfx2/viewfac.hxx>
#endif
#ifndef _COM_SUN_STAR_I18N_TRANSLITERATIONMODULES_HDL_
#include <com/sun/star/i18n/TransliterationModules.hdl>
#endif


#include "strings.hrc"
#include "glob.hrc"
#include "res_bmp.hrc"

#include "outlnvsh.hxx"
#include "sdresid.hxx"
#include "prevchld.hxx"
#include "SdUnoOutlineView.hxx"




namespace binfilter {

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::linguistic2;

#define MIN_ZOOM	       10       // Minimaler Zoomfaktor
#define MAX_ZOOM	     1000	    // Maximaler Zoomfaktor

/************************************************************************/


/*************************************************************************
|*
|* SFX-Slotmap und Standardinterface deklarieren
|*
\************************************************************************/

SFX_DECL_TYPE(13);

#define SdOutlineViewShell
#include "sdslots.hxx"

/*N*/ SFX_IMPL_INTERFACE(SdOutlineViewShell, SfxViewShell, SdResId(STR_OUTLINEVIEWSHELL))
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_OUTLINE_TOOLBOX) );
/*N*/     SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION | SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT | SFX_VISIBILITY_VIEWER | SFX_VISIBILITY_READONLYDOC,
/*N*/             					SdResId(RID_DRAW_VIEWER_TOOLBOX) );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SfxTemplateDialogWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHyperlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SdPreviewChildWindow::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SvxHlinkDlgWrapper::GetChildWindowId() );
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION( SID_SEARCH_DLG );
/*N*/ }

/*N*/ SFX_IMPL_VIEWFACTORY(SdOutlineViewShell, SdResId(STR_SPECIALVIEW) )
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION(SdDrawDocShell);
/*N*/ }

/*N*/ TYPEINIT1( SdOutlineViewShell, SdViewShell );


/*************************************************************************
|*
|* gemeinsamer Initialiserungsanteil der beiden Konstruktoren
|*
\************************************************************************/


/*************************************************************************
|*
|* Standard-Konstruktor, Fenster duerfen nicht automatisch zentrieren
|*
\************************************************************************/



/*************************************************************************
|*
|* Copy-Konstruktor
|*
\************************************************************************/


/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/


/*************************************************************************
|*
|* Paint-Methode: das Ereignis wird vom Fenster pWindow an
|* die Viewshell und die aktuelle Funktion weitergeleitet
|*
\************************************************************************/


/*************************************************************************
|*
|* Ersatz fuer AdjustPosSizePixel ab Sfx 248a
|*
\************************************************************************/


/*************************************************************************
|*
|* Ersatz fuer AdjustPosSizePixel ab Sfx 248a
|*
\************************************************************************/



/** This call is simply delegated to the base class.
*/



/*************************************************************************
|*
|* Horizontales Lineal erzeugen
|*
\************************************************************************/


/*************************************************************************
|*
|* Horizontales Lineal aktualisieren
|*
\************************************************************************/


/*************************************************************************
|*
|* SfxRequests fuer Controller bearbeiten
|*
\************************************************************************/


/*************************************************************************
|*
|* Activate(), beim ersten Aufruf erfolgt ein Update der Felder
|*
\************************************************************************/

/*************************************************************************
|*
|* Deactivate()
|*
\************************************************************************/

/*************************************************************************
|*
|* Status von Controller-SfxSlots setzen
|*
\************************************************************************/

/*************************************************************************
|*
|* SfxRequests fuer Support-Funktionen
|*
\************************************************************************/


/*************************************************************************
|*
|* SfxRequests fuer permanente Funktionen
|*
\************************************************************************/




/*************************************************************************
|*
|* Status (Enabled/Disabled) von Menue-SfxSlots setzen
|*
\************************************************************************/


/*************************************************************************
|*
|* wird gerufen, wenn ScrollBar benutzt wird
|*
\************************************************************************/


/*************************************************************************
|*
|* wird gerufen, wenn ScrollBar benutzt wird
|*
\************************************************************************/


/*************************************************************************
|*
|* PrepareClose, wird gerufen, wenn die Shell zestoert werden soll,
|* leitet den Aufruf an die View weiter
|*
\************************************************************************/



/*************************************************************************
|*
|* Zoomen mit Zoomfaktor, OutlinerView informieren
|*
\************************************************************************/


/*************************************************************************
|*
|* Zoomen mit Zoomrechteck, OutlinerView informieren
|*
\************************************************************************/



/*************************************************************************
|*
|* Vorm Speichern das Model der Drawing Engine aktualisieren, dann den
|* Call weiterleiten an die ObjectShell.
|*
\************************************************************************/


/*************************************************************************
|*
|* Read FrameViews data and set actual views data
|*
\************************************************************************/




/*************************************************************************
|*
|* Write actual views data to FrameView
|*
\************************************************************************/



/*************************************************************************
|*
|* SfxRequests fuer StatusBar bearbeiten
|*
\************************************************************************/


/*************************************************************************
|*
|* Statuswerte der Statusbar zurueckgeben
|*
\************************************************************************/


/*************************************************************************
|*
|* Command event
|*
\************************************************************************/



/*************************************************************************
|*
|* Keyboard event
|*
\************************************************************************/



/*************************************************************************
|*
|* Optimale Groesse zurueckgeben
|*
\************************************************************************/



/*************************************************************************
|*
|* Text der Selektion zurueckgeben
|*
\************************************************************************/



/*************************************************************************
|*
|* Ist etwas selektiert?
|*
\************************************************************************/



/*************************************************************************
|*
|* Status der Attribut-Items
|*
\************************************************************************/



/*************************************************************************
|*
|* MouseButtonUp event
|*
\************************************************************************/


	/*
	SfxChildWindow* pPreviewChildWindow =
		SFX_APP()->GetChildWindow(SdPreviewChildWindow::GetChildWindowId());
	if (pPreviewChildWindow)
	{
		SdPreviewWin* pPreviewWin =
			(SdPreviewWin*)pPreviewChildWindow->GetWindow();
		if (pPreviewWin)
		{
			SdPage*	pPage = GetActualPage();
			if( pPage != pLastPage )
			{
				pLastPage = pPage;
				USHORT	nPage = (pPage->GetPageNum() - 1) / 2; // Sdr --> Sd

				pPreviewWin->SetContext( pDoc, nPage, pFrameView );
			}
		}
	}
	*/

/*************************************************************************
|*
|* Liefert die erste selektierte Seite zurueck.
|* Wenn nichts selektiert ist, wird die erste Seite zurueckgeliefert.
|*
\************************************************************************/

	/* Code, der das gleiche Ergebnis liefert, gibt es schon in der
	   SdOutlinerView ! */
	/*
	Outliner* pOutl = pOlView->GetOutliner();
	DBG_ASSERT(pOutl, "kein Outliner");
	OutlinerView* pOutlinerView = pOlView->GetViewByWindow( pWindow );
	List* pList = pOutlinerView->CreateSelectionList();

	Paragraph* pSelPara = (Paragraph*)pList->First();
	USHORT nPara = 0;

	Paragraph* pPara = pOutl->First();
	BOOL bFound = pPara == pSelPara;
	while( !bFound )
	{
		BOOL bHasChilds = pOutl->HasChilds(pPara);
		if( bHasChilds )
		{
			pPara = pOutl->Next();
			while( pPara && pPara->GetDepth() != 0 && !bFound )
			{
				bFound = pPara == pSelPara;
				if( !bFound )
					pPara = pOutl->Next();
			}
		}
		if( !bFound )
		{
			if( !bHasChilds )
				pPara = pOutl->Next();
			bFound = pPara == pSelPara;
			nPara++;
		}
	}
	delete pList;

	SdPage* pPage = pDoc->GetSdPage( nPara, PK_STANDARD );
	*/


/*************************************************************************
|*
|* Retrieve range of marked pages
|*
\************************************************************************/


/*************************************************************************
|*
|* Update Preview
|*
\************************************************************************/


/*************************************************************************
|*
|* Update Title
|*
\************************************************************************/


/*************************************************************************
|*
|* Update LayoutObject
|*
\************************************************************************/



/*************************************************************************
|*
|* Outliner aus Stream fuellen
|*
\************************************************************************/





/** If there is a valid controller then create a new instance of
    <type>AccessibleDrawDocumentView</type>.  Otherwise delegate this call
    to the base class to return a default object (probably an empty
    reference).
*/




}
