/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_sdview2.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 18:46:35 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

#include <vector>

#include <bf_svx/dbexch.hrc>
#ifndef _E3D_SCENE3D_HXX 
#include <bf_svx/scene3d.hxx>
#endif

#include "strings.hrc"
#include "sdxfer.hxx"
#include "drviewsh.hxx"
#include "docshell.hxx"
#include "drawview.hxx"
#include "helpids.h"
namespace binfilter {

#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif
#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif

using namespace ::com::sun::star;

// ------------------------
// - SdNavigatorDropEvent -
// ------------------------

struct SdNavigatorDropEvent : public ExecuteDropEvent
{
    DropTargetHelper&       mrTargetHelper;
    SdWindow*               mpTargetWindow;
	USHORT					mnPage;
	USHORT					mnLayer;

				SdNavigatorDropEvent( const ExecuteDropEvent& rEvt, DropTargetHelper& rTargetHelper, 
                                      SdWindow* pTargetWindow, USHORT nPage, USHORT nLayer ) :
					ExecuteDropEvent( rEvt ), 
                    mrTargetHelper( rTargetHelper ), 
                    mpTargetWindow( pTargetWindow ),
                    mnPage( nPage ), 
                    mnLayer( nLayer ) {}
};

// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------

/*N*/ void SdView::UpdateSelectionClipboard( BOOL bForceDeselect )
/*N*/ {
/*N*/     if( pViewSh && pViewSh->GetActiveWindow() )
/*N*/     {
/*N*/ 			if( !bForceDeselect && GetMarkList().GetMarkCount() )
/*?*/ 					{DBG_BF_ASSERT(0, "STRIP");}  //STRIP001 /*?*/             CreateSelectionDataObject( this, *pViewSh->GetActiveWindow() );
/*?*/         else if( SD_MOD()->pTransferSelection && ( SD_MOD()->pTransferSelection->GetView() == this ) )
/*N*/ 			{
/*?*/  				DBG_BF_ASSERT(0, "STRIP"); //STRIP001 /*?*/             TransferableHelper::ClearSelection( pViewSh->GetActiveWindow() );
/*N*/ 			}
/*N*/     }
/*N*/ }

// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


/*************************************************************************
|*
|* Rueckgabeparameter:
|* pExchangeList == NULL -> Namen sind alle eindeutig
|* bNameOK == FALSE -> Benutzer hat abgebrochen
|* nType == 0 -> Seiten
|* nType == 1 -> Objekte
|* nType == 2 -> Seiten + Objekte
|*
\************************************************************************/


typedef std::vector< std::pair< sal_uInt32, sal_uInt32 > > PathSurrogateVector;
typedef std::vector< SdrObject* > SdrObjectVector;


/** this method restores all connections between shapes with animations along a path and theire path */

/** this method restores all connections between shapes with animations along a path and theire path */

}
