/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: desrupt.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 19:34:30 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef SFX_DESRUPT_HXX
#define SFX_DESRUPT_HXX


namespace binfilter {
//-----------------------------------------------------------------------

#define SFX_DECL_DESRUPTOR(DesruptorType, ObjectType)					\
	class DesruptorType             								    \
	{																	\
		ObjectType	*pObject;											\
		Link		 aLink; 											\
																		\
	private:															\
		DECL_LINK	(Delete,void*); 									\
																		\
	public: 															\
					 DesruptorType( ObjectType *pObjectToDesrupt ); 	\
	}

#define SFX_IMPL_DESRUPTOR(DesruptorType, ObjectType)					\
	DesruptorType::DesruptorType( ObjectType *pObjectToDesrupt ):		\
		pObject(pObjectToDesrupt),										\
		aLink( LINK(this, DesruptorType, Delete) )						\
	{																	\
		GetpApp()->InsertIdleHdl( aLink, 1 );							\
	}																	\
																		\
	IMPL_LINK(DesruptorType,Delete,void*,pvoid)							\
	{																	\
		delete pObject; 												\
		GetpApp()->RemoveIdleHdl( aLink );								\
		delete this;													\
		return 0;														\
	}


}//end of namespace binfilter
#endif
