/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_fsetvwsh.cxx,v $
 *
 *  $Revision: 1.8 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 19:49:58 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SV_MSGBOX_HXX //autogen wg. QueryBox
#include <vcl/msgbox.hxx>
#endif


#pragma hdrstop

#include "view.hrc"
#include "objface.hxx"
#include "fsetvwsh.hxx"

//=========================================================================

DBG_NAME(SfxFrameSetViewShell)

#define SfxFrameSetViewShell
#include "so3/staticbaseurl.hxx"
namespace binfilter {
#include "sfxslots.hxx"

//=========================================================================

/*N*/ TYPEINIT1(SfxFrameSetViewShell, SfxViewShell);


//=========================================================================



//=========================================================================



//-------------------------------------------------------------------------


//-------------------------------------------------------------------------




/* [Beschreibung]
 */

//-------------------------------------------------------------------------




//-------------------------------------------------------------------------


//------------------------------------------------------------------


//-------------------------------------------------------------------------


//-------------------------------------------------------------------------

/*	[Beschreibung]
	Event-Handler, "uber den das FrameSet im SplitWindow initial erzeugt
	wird.
*/

//-------------------------------------------------------------------------

/*	[Beschreibung]
	Diese Methode baut das FrameSet im SplitWindow anhand des
	"ubergebenen FrameSetDescriptors neu auf, indem es das SplitWindow
	leert und dann wieder neu f"ullt.
	Aus Performance-Gr"unden wird nur das Splitwindow geleert, die Frames
	aber nicht sofort geclosed, um sie gleich wieder ins Splitwindow einf"ugen
	zu k"onnen, ohne die Dokumente neu laden zu m"ussen.
*/

//------------------------------------------------------------------------

/*	[Beschreibung]
	Mit dieser Methode wird das FrameSet im SplitWindow anhand des
	"ubergebenen FrameSetDescriptors gef"ullt.
*/

//-------------------------------------------------------------------------

/*	[Beschreibung]

	Mit dieser Methode wird aus einem FrameSetDescriptor ein ItemSet in
	einem SplitWindow gef"ullt ( nSet = 0 ist das RootSet ).
	F"ur jeden FrameDescriptor im FrameSetDescriptor wird ein SfxURLFrame
	mit gleicher ItemId erzeugt, sofern ein SfxURLFrame der gleichen ItemId
	nicht schon vorhanden ist, weil MakeWindows nicht zum Neuaufbau des
	FrameSets, sondern zum Update mit einem ver"anderten FrameSetDescriptor
	aufgerufen wurde.
	SfxURLFrames mit Descriptoren, die wieder ein FrameSet enthalten, f"ugen
	ein ItemSet in das SplitWindow ein, solche ohne FrameSet ein ItemWindow.
*/

//------------------------------------------------------------------


//------------------------------------------------------------------

/*N*/ SfxFrameSetViewShell::SfxFrameSetViewShell(
/*N*/ 	SfxViewFrame *pFrame, const SfxFrameSetViewShell& rWin, sal_uInt16 nFlags ):
/*N*/ 	SfxViewShell( pFrame, nFlags ),
/*N*/ 	bEditMode( sal_False ),
/*N*/ 	pImp( NULL ),
/*N*/ 	pDescriptor( NULL )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//------------------------------------------------------------------

/*N*/ SfxFrameSetViewShell::SfxFrameSetViewShell(
/*N*/ 	SfxViewFrame *pFrame, SfxViewShell*, sal_uInt16 nFlags ):
/*N*/ 	SfxViewShell( pFrame, nFlags ),
/*N*/ 	bEditMode( sal_False ),
/*N*/ 	pDescriptor( NULL )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }
//------------------------------------------------------------------

/*N*/ SfxFrameSetViewShell::~SfxFrameSetViewShell()
/*N*/ {
/*N*/ 	DBG_BF_ASSERT(0, "STRIP"); //STRIP001 DBG_DTOR(SfxFrameSetViewShell, 0);
/*N*/ }

//------------------------------------------------------------------


//------------------------------------------------------------------------


//------------------------------------------------------------------------


//------------------------------------------------------------------------


//-------------------------------------------------------------------------

/*	[Beschreibung]

	Diese Methode ersetzt ein ItemWindow oder ItemSet durch ein
	anderes ItemWindow oder ItemSet, wenn sich der Inhalt eines URLFrames
	entsprechend ge"andert hat.
 */



















}
