/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_intfrm.cxx,v $
 *
 *  $Revision: 1.7 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 19:50:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

#include "intfrm.hxx"
#include "sfxtypes.hxx"
#include "dispatch.hxx"
#include "sfxresid.hxx"

#include "sfx.hrc"

// STATIC DATA -----------------------------------------------------------


#define SfxInternalFrame
namespace binfilter {
#include "sfxslots.hxx"


class SfxInternalWin_Impl : public Window
{
friend class SfxInternalFrame;

	BOOL				bActive;
	SfxInternalFrame*	pFrame;

public:
						SfxInternalWin_Impl( SfxInternalFrame* p,
								Window *pParent, WinBits nBits=0 ) :
							Window( pParent, nBits | WB_BORDER | WB_CLIPCHILDREN ),
							pFrame( p ),
							bActive( FALSE )
						{
							SetBorderStyle( WINDOW_BORDER_NOBORDER );
						}

};

//--------------------------------------------------------------------

//--------------------------------------------------------------------

/*N*/ SFX_IMPL_INTERFACE(SfxInternalFrame,SfxViewFrame,SfxResId(0))
/*N*/ {
/*N*/ }

//--------------------------------------------------------------------
/*N*/ void SfxInternalFrame::Exec_Impl(SfxRequest &rReq)
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//--------------------------------------------------------------------
/*N*/ void SfxInternalFrame::GetState_Impl(SfxItemSet &rSet)
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//--------------------------------------------------------------------

//--------------------------------------------------------------------

//--------------------------------------------------------------------
/*N*/ void SfxInternalFrame::SetZoomFactor( const Fraction &rZoomX,
/*N*/ 									 const Fraction &rZoomY )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//--------------------------------------------------------------------

/*	[Beschreibung]

	SfxInternalFrames haben einen fest zugeordneten Namen und bekommen
	NICHT den des Dokuments mit angeh"angter Nummer. Daher wird die
	Basismethode <SfxViewFrame::UpdataeTitle()> abgefangen.
*/


//--------------------------------------------------------------------

//--------------------------------------------------------------------

//--------------------------------------------------------------------

// CTOR / DTOR -----------------------------------------------------------
/*N*/ SfxInternalFrame::SfxInternalFrame( Window *pWindow, SfxFrame *pFrame,
/*N*/ 		SfxInternalFrameData_Impl *pData, SfxObjectShell *pDoc )
/*N*/ 	: SfxViewFrame( pData->bHasToolSpace ? *(new SfxBindings) :
/*N*/ 		pFrame->GetParentFrame()->GetCurrentViewFrame()->GetBindings(),
/*N*/ 		pFrame, pDoc )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//-------------------------------------------------------------------------
/*N*/ SfxInternalFrame::~SfxInternalFrame()
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//--------------------------------------------------------------------

/*	[Beschreibung]

	Erzeugt eine (die erste und einzige) SfxViewShell f"ur diesen
	SfxInternalFrame.
*/


//------------------------------------------------------------------------
/*N*/ void SfxInternalFrame::InvalidateBorderImpl( const SfxViewShell* pViewSh )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
/*N*/ }

//------------------------------------------------------------------------

//--------------------------------------------------------------------

//--------------------------------------------------------------------

//--------------------------------------------------------------------


}
