/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_chardlg.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 20:11:43 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _UNO_LINGU_HXX
#include <unolingu.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif
#ifndef _SFONTITM_HXX
#include <svtools/sfontitm.hxx>
#endif
#ifndef _SFX_PRINTER_HXX //autogen
#include <bf_sfx2/printer.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <bf_sfx2/objsh.hxx>
#endif
#ifndef _SFXVIEWSH_HXX
#include <bf_sfx2/viewsh.hxx>
#endif
#ifndef _SFX_BINDINGS_HXX
#include <bf_sfx2/bindings.hxx>
#endif
#ifndef _SFXVIEWFRM_HXX
#include <bf_sfx2/viewfrm.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#pragma hdrstop

#define _SVX_CHARDLG_CXX

#ifndef _SVTOOLS_LANGUAGEOPTIONS_HXX
#include <svtools/languageoptions.hxx>
#endif

#include "dialogs.hrc"
#include "svxitems.hrc"
#include "chardlg.hrc"
namespace binfilter {

//Erstmal definieren, damit die Klassendeklarionen angezogen werden.
#define ITEMID_FONT 			SID_ATTR_CHAR_FONT
#define ITEMID_POSTURE			SID_ATTR_CHAR_POSTURE
#define ITEMID_WEIGHT			SID_ATTR_CHAR_WEIGHT
#define ITEMID_SHADOWED 		SID_ATTR_CHAR_SHADOWED
#define ITEMID_WORDLINEMODE 	SID_ATTR_CHAR_WORDLINEMODE
#define ITEMID_CONTOUR			SID_ATTR_CHAR_CONTOUR
#define ITEMID_CROSSEDOUT		SID_ATTR_CHAR_STRIKEOUT
#define ITEMID_UNDERLINE		SID_ATTR_CHAR_UNDERLINE
#define ITEMID_FONTHEIGHT		SID_ATTR_CHAR_FONTHEIGHT
#define ITEMID_PROPSIZE 		SID_ATTR_CHAR_PROPSIZE
#define ITEMID_COLOR			SID_ATTR_CHAR_COLOR
#define ITEMID_KERNING			SID_ATTR_CHAR_KERNING
#define ITEMID_CASEMAP			SID_ATTR_CHAR_CASEMAP
#define ITEMID_LANGUAGE 		SID_ATTR_CHAR_LANGUAGE
#define ITEMID_ESCAPEMENT		SID_ATTR_CHAR_ESCAPEMENT
#define ITEMID_FONTLIST 		SID_ATTR_CHAR_FONTLIST
#define ITEMID_AUTOKERN 		SID_ATTR_CHAR_AUTOKERN
#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_BLINK			SID_ATTR_FLASH
#define ITEMID_BRUSH			SID_ATTR_BRUSH
#define ITEMID_EMPHASISMARK		SID_ATTR_CHAR_EMPHASISMARK
#define ITEMID_TWOLINES			SID_ATTR_CHAR_TWO_LINES
#define ITEMID_CHARROTATE		SID_ATTR_CHAR_ROTATED
#define ITEMID_CHARSCALE_W		SID_ATTR_CHAR_SCALEWIDTH
#define ITEMID_CHARRELIEF       SID_ATTR_CHAR_RELIEF

#include "xtable.hxx"		// XColorTable
#include "chardlg.hxx"
#include "fontitem.hxx"
#include "postitem.hxx"
#include "udlnitem.hxx"
#include "crsditem.hxx"
#include "cntritem.hxx"
#include "langitem.hxx"
#include "wghtitem.hxx"
#include "fhgtitem.hxx"
#include "shdditem.hxx"
#include "escpitem.hxx"
#include "prszitem.hxx"
#include "wrlmitem.hxx"
#include "cmapitem.hxx"
#include "kernitem.hxx"
#include "blnkitem.hxx"
#include "flstitem.hxx"
#include "akrnitem.hxx"
#include "brshitem.hxx"
#include "colritem.hxx"
#include "drawitem.hxx"
#include "dlgutil.hxx"
#include "dialmgr.hxx"
#include "htmlmode.hxx"
#include "charmap.hxx"
#include "chardlg.h"
#include "emphitem.hxx"
#include <charreliefitem.hxx>
#include "twolinesitem.hxx"

#ifndef _SVX_CHARSCALEITEM_HXX
#include <charscaleitem.hxx>
#endif
#ifndef _SVX_CHARROTATEITEM_HXX
#include <charrotateitem.hxx>
#endif

using namespace ::com::sun::star;

// define ----------------------------------------------------------------


}
