/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_dbtoolsclient.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 20:53:34 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef SVX_DBTOOLSCLIENT_HXX
#include "dbtoolsclient.hxx"
#endif
#ifndef _OSL_DIAGNOSE_H_
#include <osl/diagnose.h>
#endif
#include <tools/debug.hxx> //for stripping
namespace binfilter {
//........................................................................
namespace svxform
{
//........................................................................

	using namespace ::connectivity::simple;
	using namespace ::com::sun::star::sdbc;
	using namespace ::com::sun::star::lang;
	using namespace ::com::sun::star::util;
	using namespace ::com::sun::star::uno;
	using namespace ::com::sun::star::beans;
	using namespace ::com::sun::star::sdb;
	using namespace ::com::sun::star::container;

	//====================================================================
	//= ODbtoolsClient
	//====================================================================
	::osl::Mutex	ODbtoolsClient::s_aMutex;
	sal_Int32		ODbtoolsClient::s_nClients = 0;
	oslModule		ODbtoolsClient::s_hDbtoolsModule = NULL;
	createDataAccessToolsFactoryFunction
					ODbtoolsClient::s_pFactoryCreationFunc = NULL;

	//--------------------------------------------------------------------
/*N*/ 	ODbtoolsClient::ODbtoolsClient()
/*N*/ 	{
/*N*/ 		m_bCreateAlready = FALSE;
/*N*/ 	}

	//--------------------------------------------------------------------
	//add by BerryJia for fixing Bug97420 Time:2002-9-12-11:00(PRC time)

	//--------------------------------------------------------------------
/*N*/ 	ODbtoolsClient::~ODbtoolsClient()
/*N*/ 	{
/*N*/ 		// clear the factory _before_ revoking the client
/*N*/ 		// (the revocation may unload the DBT lib)
/*N*/ 		m_xDataAccessFactory = NULL;
/*N*/ 		// revoke the client
/*N*/ 		if ( m_bCreateAlready )
				{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 /*?*/ 			revokeClient();
/*N*/ 	}

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//====================================================================
	//= OStaticDataAccessTools
	//====================================================================
	//--------------------------------------------------------------------
/*N*/ 	OStaticDataAccessTools::OStaticDataAccessTools()
/*N*/ 	{
/*N*/ 	}

	//--------------------------------------------------------------------
	//add by BerryJia for fixing Bug97420 Time:2002-9-12-11:00(PRC time)
	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//--------------------------------------------------------------------

	//----------------------------------------------------------------

	//----------------------------------------------------------------

	//----------------------------------------------------------------

	//----------------------------------------------------------------

	//----------------------------------------------------------------
/*?*/ 	Reference< XNameAccess > OStaticDataAccessTools::getFieldsByCommandDescriptor( const Reference< XConnection >& _rxConnection,
/*?*/ 		const sal_Int32 _nCommandType, const ::rtl::OUString& _rCommand,
/*?*/ 			Reference< XComponent >& _rxKeepFieldsAlive, ::dbtools::SQLExceptionInfo* _pErrorInfo ) SAL_THROW( ( ) )
/*?*/ 	{DBG_BF_ASSERT(0, "STRIP");	Reference< XNameAccess > aFields; return aFields;//STRIP001 
/*?*/ }

	//----------------------------------------------------------------
/*?*/ 	Sequence< ::rtl::OUString > OStaticDataAccessTools::getFieldNamesByCommandDescriptor(
/*?*/ 		const Reference< XConnection >& _rxConnection, const sal_Int32 _nCommandType,
/*?*/ 		const ::rtl::OUString& _rCommand, ::dbtools::SQLExceptionInfo* _pErrorInfo ) SAL_THROW( ( ) )
/*?*/ 	{DBG_BF_ASSERT(0, "STRIP"); Sequence< ::rtl::OUString > aNames; return aNames;//STRIP001 
/*?*/ 	}

//........................................................................
}	// namespace svxform
//........................................................................


}
