/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svx_grafctrl.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/27 21:50:39 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#define ITEMID_SIZE 0 
#define ITEMID_BRUSH 0
#define ITEMID_GRF_CROP SID_ATTR_GRAF_CROP

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers


#ifndef _SVTOOLS_IMGDEF_HXX
#include <svtools/imgdef.hxx>
#endif

#ifndef _SFXTBXMGR_HXX //autogen
#include <bf_sfx2/tbxmgr.hxx>
#endif

#include "svxids.hrc"
#include "grafctrl.hrc"
#include "dialogs.hrc"

#ifndef _XDEF_HXX
#include "xdef.hxx"
#endif

#include "grafctrl.hxx"
namespace binfilter {

// -----------
// - Defines -
// -----------

#define SYMBOL_TO_FIELD_OFFSET		4
#define ITEMVALUE(ItemSet,Id,Cast)	((const Cast&)(ItemSet).Get(Id)).GetValue()

// ----------------
// - TbxImageItem -
// ----------------

/*N*/ TYPEINIT1( TbxImageItem, SfxUInt16Item );

//---------------------------------------------------------

/*N*/ TbxImageItem::TbxImageItem( USHORT nWhich, UINT16 nImage ) :
/*N*/ 	SfxUInt16Item( nWhich, nImage )
/*N*/ {
/*N*/ }

//---------------------------------------------------------


//---------------------------------------------------------


// -----------------------
// - ImplGrafMetricField -
// -----------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// --------------------
// - ImplGrafControl  -
// --------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------
// - ImplGrafModeControl -
// -----------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------------------------------------------------------


// -----------------------
// - ImplGrafFilterPopup -
// -----------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -------------------------------
// - SvxGrafFilterToolBoxControl -
// -------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafFilterToolBoxControl, TbxImageItem );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafFilterToolBoxControl::SvxGrafFilterToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 	SfxToolBoxControl( nId, rTbx, rBind )
/*?*/ {
/*?*/ }

// -----------------------------------------------------------------------------
	

// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -------------------------
// - SvxGrafToolBoxControl -
// -------------------------


// -----------------------------------------------------------------------------

/*?*/ SvxGrafToolBoxControl::SvxGrafToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 	SfxToolBoxControl	( nId, rTbx, rBind )
/*?*/ {
/*?*/ DBG_BF_ASSERT(0, "STRIP"); //STRIP001 //STRIP001 	SfxApplication* pSfxApp = SFX_APP();
/*?*/ }

// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// ----------------------------
// - SvxGrafRedToolBoxControl -
// ----------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafRedToolBoxControl, SfxInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafRedToolBoxControl::SvxGrafRedToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// ------------------------------
// - SvxGrafGreenToolBoxControl -
// ------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafGreenToolBoxControl, SfxInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafGreenToolBoxControl::SvxGrafGreenToolBoxControl(	USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// -----------------------------
// - SvxGrafBlueToolBoxControl -
// -----------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafBlueToolBoxControl, SfxInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafBlueToolBoxControl::SvxGrafBlueToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// ----------------------------------
// - SvxGrafLuminanceToolBoxControl -
// ----------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafLuminanceToolBoxControl, SfxInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafLuminanceToolBoxControl::SvxGrafLuminanceToolBoxControl( USHORT nId, ToolBox& rTbx,
/*?*/ 																SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// ----------------------------------
// - SvxGrafContrastToolBoxControl -
// ----------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafContrastToolBoxControl, SfxInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafContrastToolBoxControl::SvxGrafContrastToolBoxControl( USHORT nId, ToolBox& rTbx,
/*?*/ 															  SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// ------------------------------
// - SvxGrafGammaToolBoxControl -
// ------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafGammaToolBoxControl, SfxUInt32Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafGammaToolBoxControl::SvxGrafGammaToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// -------------------------------------
// - SvxGrafTransparenceToolBoxControl -
// -------------------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafTransparenceToolBoxControl, SfxUInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafTransparenceToolBoxControl::SvxGrafTransparenceToolBoxControl( USHORT nId, ToolBox& rTbx,
/*?*/ 																	  SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SvxGrafToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ }

// -----------------------------
// - SvxGrafModeToolBoxControl -
// -----------------------------

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxGrafModeToolBoxControl, SfxUInt16Item );

// -----------------------------------------------------------------------------

/*?*/ SvxGrafModeToolBoxControl::SvxGrafModeToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SfxToolBoxControl( nId, rTbx, rBind )
/*?*/ 
/*?*/ {
/*?*/ DBG_BF_ASSERT(0, "STRIP"); //STRIP001 //STRIP001 	SfxApplication* pSfxApp = SFX_APP();
/*?*/ }

// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------


// ---------------------
// - SvxGrafAttrHelper -
// ---------------------


// -----------------------------------------------------------------------------

}
