/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: offuiks.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/28 02:25:54 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _OFFUIKS_HRC
#define _OFFUIKS_HRC

namespace binfilter {

#define UIK_XTEXT          			UIK_TEXT(01)
#define UIK_XTEXT_POSITIONS         UIK_TEXT(02)
#define UIK_XTEXT_POSITION          UIK_TEXT(03)
#define UIK_XTEXT_COLUMNS          	UIK_TEXT(04)
#define UIK_XCURSOR          		UIK_TEXT(05)
#define UIK_XPAGE_CURSOR          	UIK_TEXT(06)
#define UIK_XTEXT_CURSOR          	UIK_TEXT(07)
#define UIK_XWORD_CURSOR          	UIK_TEXT(08)
#define UIK_XSENTENCE_CURSOR        UIK_TEXT(09)
#define UIK_XPARAGRAPH_CURSOR       UIK_TEXT(0a)
#define UIK_XAUTO_TEXT_GROUP        UIK_TEXT(0b)
#define UIK_XAUTO_TEXT_CONTAINER    UIK_TEXT(0c)
#define UIK_XTAB_STOPS          	UIK_TEXT(0d)
#define UIK_XTEXT_SEARCHABLE        UIK_TEXT(0e)
#define UIK_XTEXT_SEARCH          	UIK_TEXT(0f)
#define UIK_XTEXT_REPLACE          	UIK_TEXT(10)
#define UIK_XPROPERTY_REPLACE       UIK_TEXT(11)
#define UIK_XSEARCH_PROPERTIES      UIK_TEXT(12)
#define UIK_XCONTROL_CHARACTER_INSERTABLE	UIK_TEXT(13)
#define UIK_XOFFICE_TEXT_FIELDS				UIK_TEXT(14)
#define UIK_XNAMED_TEXT_FIELD_TYPE			UIK_TEXT(15)
#define UIK_XOFFICE_TEXT_FIELD				UIK_TEXT(16)
#define UIK_XFIELD_TYPES            		UIK_TEXT(17)
#define UIK_XOFFICE_TEXT_FIELD_TYPE         UIK_TEXT(18)
#define UIK_XTEXT_FIELD             		UIK_TEXT(19)
#define UIK_XNAMED_FIELD_TYPE             	UIK_TEXT(1a)
#define UIK_XTEXT_POSITION_COMBINER         UIK_TEXT(1b)
#define UIK_XPARAGRAPH         				UIK_TEXT(1c)
#define UIK_XPARAGRAPH_ENUMERATOR         	UIK_TEXT(1d)

#define UIK_XDOCUMENT_VIEW          	UIK_STARDESKTOP(01)
#define UIK_XSTYLE_FAMILIES         	UIK_STARDESKTOP(02)
#define UIK_XSTYLE_FAMILY          		UIK_STARDESKTOP(03)
#define UIK_XSTYLE     					UIK_STARDESKTOP(04)
#define UIK_XHEADER_FOOTER				UIK_STARDESKTOP(05)
#define UIK_XHEADER_FOOTER_PAGE_STYLE   UIK_STARDESKTOP(06)
#define UIK_XSTYLE_CONDITION			UIK_STARDESKTOP(07)
#define UIK_XTHESAURUS    				UIK_STARDESKTOP(08)
#define UIK_XSPELL_CHECKER 				UIK_STARDESKTOP(09)
#define UIK_XHYPHENATOR          		UIK_STARDESKTOP(0a)
#define UIK_XDICTIONARY          		UIK_STARDESKTOP(0b)
#define UIK_XDICTIONARIES         		UIK_STARDESKTOP(0c)
#define UIK_XACTION_LOCKABLE           	UIK_STARDESKTOP(0d)
#define UIK_XPRINT_PREVIEW              UIK_STARDESKTOP(0e)
#define UIK_XGRAPHIC_OBJECTS          	UIK_STARDESKTOP(0f)
#define UIK_XGRAPHIC_OBJECT           	UIK_STARDESKTOP(10)
#define UIK_XOLE_OBJECTS       			UIK_STARDESKTOP(11)
#define UIK_XOLE_OBJECT        			UIK_STARDESKTOP(12)
#define UIK_XPROPERTYSET_CLONER         UIK_STARDESKTOP(13)

#define UIK_XCELL						UIK_TABLE(00)
#define UIK_XCELLRANGE					UIK_TABLE(01)
#define UIK_XTABLEAUTOFORMAT			UIK_TABLE(02)
#define UIK_XTABLEAUTOFORMATS			UIK_TABLE(03)
#define UIK_XAUTOFORMATTABLE			UIK_TABLE(04)
#define UIK_XPROTECTABLE				UIK_TABLE(05)
#define UIK_XCLIPBOARDSOURCE			UIK_TABLE(06)
#define UIK_XPRINTABLE					UIK_TABLE(07)
#define UIK_XSORTDESCRIPTOR				UIK_TABLE(08)
#define UIK_XSORTABLE					UIK_TABLE(09)

} //namespace binfilter
#endif

