/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: ipfrm.hxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/28 03:02:04 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SFX_IPFRM_HXX
#define _SFX_IPFRM_HXX

#include <bf_sfx2/viewfrm.hxx>
#include <bf_sfx2/objface.hxx>
#include <bf_sfx2/objsh.hxx>

#ifndef _RTTI_HXX
#include <tools/rtti.hxx>
#endif
class SfxItemSet;
class SfxItemPool;
namespace binfilter {

class SfxViewShell;
class SfxInPlaceFrame;
class SfxInPlaceEnv_Impl;
class SvInPlaceClipWindow;
class SvInPlaceWindow;
class SfxConfigManager;
class SfxBorderWindow;
struct SfxInPlaceFrame_Impl;

// -----------------------------------------------------------------------

class SfxInPlaceFrame: public SfxViewFrame
{
friend class SfxBorderWindow; // Resize aufrufen

	SfxInPlaceFrame_Impl*	pImp; // unused
	SfxInPlaceEnv_Impl*     pEnv;
	SfxViewShell*			pViewShell;

protected:
							// Forwarding zwischen SfxInternalObject und SfxViewShell
	virtual void            Activate( BOOL bUI ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void            Activate( BOOL bUI );
	virtual void            Deactivate( BOOL bUI ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void            Deactivate( BOOL bUI );
	virtual BOOL            Close(){DBG_BF_ASSERT(0, "STRIP"); return FALSE;} //STRIP001 virtual BOOL            Close();

	virtual void            SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
									const SfxHint& rHint, const TypeId& rHintType ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 const SfxHint& rHint, const TypeId& rHintType );
	virtual void            ShowStatusText( const String& rText ){DBG_ASSERT(0, "STRIP") ; } //STRIP001 virtual void            ShowStatusText( const String& rText );
	virtual void            HideStatusText(){DBG_ASSERT(0, "STRIP") ; } //STRIP001 virtual void            HideStatusText();
	virtual                 ~SfxInPlaceFrame(){DBG_ASSERT(0, "STRIP") ; } //STRIP001 virtual                 ~SfxInPlaceFrame();

public:
							TYPEINFO();
							SFX_DECL_INTERFACE(SFX_INTERFACE_SFXIPFRM) ;

							SfxInPlaceFrame() : SfxViewFrame() {}

	virtual void            SetZoomFactor( const Fraction &rZoomX,
										   const Fraction &rZoomY );


	virtual void            Optimize(){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void            Optimize();


	virtual BOOL			SetBorderPixelImpl( const SfxViewShell *pSh,
												const SvBorder &rBorder ){DBG_BF_ASSERT(0, "STRIP"); return FALSE;} //STRIP001 const SvBorder &rBorder );
	virtual const SvBorder& GetBorderPixelImpl( const SfxViewShell *pSh ) const;
	virtual void			InvalidateBorderImpl( const SfxViewShell *pSh );

#ifndef _SFXDOC_HXX
#endif
};

}//end of namespace binfilter
#endif

