/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: urlframe.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/28 03:11:20 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SFXURLFRAME_HXX
#define _SFXURLFRAME_HXX

#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif

#include "bf_sfx2/frame.hxx"
#include "bf_sfx2/frmdescr.hxx"
class SvInPlaceEnvironment;
namespace binfilter {

class SfxObjectShell;
class DockingWindow;
class SfxFrameEnv_Impl;
class SfxFrameDescriptor;
class SfxReleasableFrame;

//==========================================================================
// Ein SfxURLFrame stellt ein Fenster zur Verf"ugung, in dem ein beliebiger
// Inhalt, spezifiziert durch einen URL, dargestellt werden kann. Ein solcher
// SfxFrame ist immer Teil einer SfxFrameSetViewShell, die ein splitbares
// Fenster zur Verf"ugung stellt, in dem alle ChildFrames liegen.
//==========================================================================

class SfxURLFrame : public SfxFrame
{

#if _SOLAR__PRIVATE
#endif

protected:
	virtual BOOL			Close(){DBG_BF_ASSERT(0, "STRIP"); return FALSE;} //STRIP001 virtual BOOL			Close();
	virtual void        	SFX_NOTIFY( SfxBroadcaster& rBC,
									const TypeId& rBCType,
									const SfxHint& rHint,
									const TypeId& rHintType ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 const TypeId& rHintType );
	virtual         		~SfxURLFrame();

public:
							TYPEINFO();
							SfxURLFrame(SfxFrameDescriptor* pDescr,
										SvInPlaceEnvironment* pObj,
										SfxReleasableFrame* pRel,
										SfxFrame* pParent );

							virtual Window&     	GetWindow() const{DBG_BF_ASSERT(0, "STRIP"); Window aWindow(NULL,0); return aWindow;} //STRIP001 virtual Window&     	GetWindow() const;
	virtual BOOL			InsertDocument( SfxObjectShell *pDoc){DBG_BF_ASSERT(0, "STRIP"); return FALSE;} //STRIP001 virtual BOOL			InsertDocument( SfxObjectShell *pDoc);
	virtual void			InsertWindow( Window* ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void			InsertWindow( Window* );
};

}//end of namespace binfilter
#endif

