/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: viewuno.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 12:46:04 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _VIEWUNO_HXX
#define _VIEWUNO_HXX

#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTOR_HPP_
#include <com/sun/star/frame/XDispatchProviderInterceptor.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTATUSLISTENER_HPP_
#include <com/sun/star/frame/XStatusListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMESEARCHFLAG_HPP_
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDERINTERCEPTION_HPP_
#include <com/sun/star/frame/XDispatchProviderInterception.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FEATURESTATEEVENT_HPP_
#include <com/sun/star/frame/FeatureStateEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_DISPATCHDESCRIPTOR_HPP_
#include <com/sun/star/frame/DispatchDescriptor.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
#include <com/sun/star/frame/XStorable.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMEACTIONLISTENER_HPP_
#include <com/sun/star/frame/XFrameActionListener.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
#include <com/sun/star/frame/XComponentLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMEACTIONEVENT_HPP_
#include <com/sun/star/frame/FrameActionEvent.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_FRAMEACTION_HPP_
#include <com/sun/star/frame/FrameAction.hpp>
#endif
#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#include <bf_sfx2/viewsh.hxx>
#include <bf_sfx2/sfxuno.hxx>
namespace binfilter {

class SfxOfficeDocCtrl_Impl;
class SfxOfficeDocController : public ::com::sun::star::frame::XController, public ::com::sun::star::frame::XDispatchProvider
{
	SfxOfficeDocCtrl_Impl*		pImp;

private:
	SfxViewShell*				pViewShell;

public:
								SfxOfficeDocController(SfxViewShell* pView);
								~SfxOfficeDocController();

								// ::com::sun::star::frame::XController
	virtual void   SAL_CALL				attachFrame( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xFrame ) throw (::com::sun::star::uno::RuntimeException );
	virtual sal_Bool   SAL_CALL					attachModel( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > & xModel ) throw (::com::sun::star::uno::RuntimeException );
	virtual sal_Bool   SAL_CALL					suspend( sal_Bool bSuspend ) throw (::com::sun::star::uno::RuntimeException );
	::com::sun::star::uno::Any	    SAL_CALL						getViewData() throw (::com::sun::star::uno::RuntimeException );
	void		   SAL_CALL					restoreViewData( const ::com::sun::star::uno::Any& Value ) throw (::com::sun::star::uno::RuntimeException );
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > 	  SAL_CALL					getFrame() throw (::com::sun::star::uno::RuntimeException );
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XModel > 	  SAL_CALL					getModel() throw (::com::sun::star::uno::RuntimeException );

								// ::com::sun::star::frame::XDispatchProvider
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >   SAL_CALL			queryDispatch( const ::com::sun::star::util::URL& aURL,
									const ::rtl::OUString& aTargetFrameName,
									FrameSearchFlags nSearchFlags) throw (::com::sun::star::uno::RuntimeException );
	virtual ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatch >  > SAL_CALL	 queryDispatches(
									const ::com::sun::star::uno::Sequence< ::com::sun::star::frame::DispatchDescriptor >& aDescripts) throw (::com::sun::star::uno::RuntimeException );

								// ::com::sun::star::lang::XComponent
	virtual void	  SAL_CALL				dispose() throw (::com::sun::star::uno::RuntimeException );
	virtual void 	  SAL_CALL				addEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener ) throw (::com::sun::star::uno::RuntimeException );
	virtual void 	  SAL_CALL				removeEventListener( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XEventListener > & aListener ) throw (::com::sun::star::uno::RuntimeException );
};

class SfxFrameActionListener : public ::com::sun::star::frame::XFrameActionListener,
								public ::com::sun::star::lang::XTypeProvider,
								public ::cppu::OWeakObject
{
public:
	::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > 							xFrame;

	SFX_DECL_XINTERFACE_XTYPEPROVIDER

										SfxFrameActionListener( const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > & xRef )
											: xFrame( xRef )
										{}

    virtual void 		 SAL_CALL				frameAction(const ::com::sun::star::frame::FrameActionEvent& aEvent) throw (::com::sun::star::uno::RuntimeException );
	virtual void 	  SAL_CALL					disposing( const ::com::sun::star::lang::EventObject& Source ) throw (::com::sun::star::uno::RuntimeException );
};

}//end of namespace binfilter
#endif

