/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: grafctrl.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2006/10/28 03:36:31 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_GRAFCTRL_HXX
#define _SVX_GRAFCTRL_HXX

#ifndef _SFXLSTNER_HXX //autogen
#include <svtools/lstner.hxx>
#endif
#ifndef _SFXINTITEM_HXX
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXTBXCTRL_HXX //autogen
#include <bf_sfx2/tbxctrl.hxx>
#endif
namespace binfilter {

// ----------------
// - TbxImageItem -
// ----------------

class TbxImageItem : public SfxUInt16Item
{
public:
							TYPEINFO();
							TbxImageItem( USHORT nWhich = 0, UINT16 nImage = 0 );

};

// -------------------------------
// - SvxGrafFilterToolBoxControl -
// -------------------------------

class SvxGrafFilterToolBoxControl : public SfxToolBoxControl
{
public:

								SFX_DECL_TOOLBOX_CONTROL();
								SvxGrafFilterToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// -------------------------
// - SvxGrafToolBoxControl -
// -------------------------

class SvxGrafToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
						SvxGrafToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ----------------------------
// - SvxGrafRedToolBoxControl -
// ----------------------------

class SvxGrafRedToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafRedToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ------------------------------
// - SvxGrafGreenToolBoxControl -
// ------------------------------

class SvxGrafGreenToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafGreenToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// -----------------------------
// - SvxGrafBlueToolBoxControl -
// -----------------------------

class SvxGrafBlueToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafBlueToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ----------------------------------
// - SvxGrafLuminanceToolBoxControl -
// ----------------------------------

class SvxGrafLuminanceToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafLuminanceToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ---------------------------------
// - SvxGrafContrastToolBoxControl -
// ---------------------------------

class SvxGrafContrastToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafContrastToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ------------------------------
// - SvxGrafGammaToolBoxControl -
// ------------------------------

class SvxGrafGammaToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafGammaToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// -------------------------------------
// - SvxGrafTransparenceToolBoxControl -
// -------------------------------------

class SvxGrafTransparenceToolBoxControl : public SvxGrafToolBoxControl
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafTransparenceToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// -----------------------------
// - SvxGrafModeToolBoxControl -
// -----------------------------

class SvxGrafModeToolBoxControl : public SfxToolBoxControl, public SfxListener
{
public:
						SFX_DECL_TOOLBOX_CONTROL();
						SvxGrafModeToolBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind );
};

// ---------------------
// - SvxGrafAttrHelper -
// ---------------------

class SdrView;
class SfxRequest;


}//end of namespace binfilter
#endif // _SVX_GRAFCTRL_HXX
