/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: lightdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:47:05 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_LIGHT3D_HXX_
#define _SVX_LIGHT3D_HXX_

#include <bf_svx/dlgctl3d.hxx>

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SVX_DLG_CTRL_HXX //autogen
#include <bf_svx/dlgctrl.hxx>
#endif
class Vector3D;
namespace binfilter {


/*************************************************************************
|*
|* Dialog
|*
\************************************************************************/
/*
class SvxLight3DDlg : public ModalDialog
{
private:
	SvxRectCtl3D	aCtlLight;
	FixedText		aFtIntensity;
	MetricField		aMtrFldIntensity;
	OKButton		aBtnOK;
	CancelButton	aBtnCancel;
	HelpButton		aBtnHelp;

public:
	SvxLight3DDlg(Window* pWindow);
	virtual		~SvxLight3DDlg();

	Vector3D	GetVector();
	void		SetLight( Vector3D aVect );
	double  	GetIntensity();
	void		SetIntensity( double fIntens );
};
*/
/*************************************************************************
|*
|* 3D-Tab-Dialog
|*
\************************************************************************/

class Svx3DTabDialog : public SfxTabDialog
{
private:
	const SfxItemSet&	rOutAttrs;

public:
			Svx3DTabDialog( Window* pParent, const SfxItemSet* pAttr );
			~Svx3DTabDialog();
};

/*************************************************************************
|*
|* 3D-SingleTab-Dialog
|*
\************************************************************************/
class Svx3DSingleTabDialog : public SfxSingleTabDialog
{
private:
	const SfxItemSet&	rOutAttrs;

public:
		Svx3DSingleTabDialog( Window* pParent, const SfxItemSet* pAttr );
		~Svx3DSingleTabDialog();
};

/*************************************************************************
|*
|* Light-Tab-Page
|*
\************************************************************************/
class SvxLight3DTabPage : public SfxTabPage
{
private:
	SvxRectCtl3D		aCtlLight;
	FixedText			aFtLightIntensity;
	MetricField			aMtrFldLightIntensity;
	FixedText			aFtLightColor;
	ColorLB  			aLbLightColor;
	GroupBox			aGrpLight;
	FixedText			aFtIntensity;
	MetricField			aMtrFldIntensity;
	FixedText			aFtColor;
	ColorLB  			aLbColor;
	GroupBox			aGrpAmbient;
	const SfxItemSet&	rOutAttrs;

public:
		 SvxLight3DTabPage( Window* pParent, const SfxItemSet& rInAttrs  );

	static SfxTabPage* Create( Window*, const SfxItemSet& );
	static USHORT*	   GetRanges();

	virtual BOOL FillItemSet( SfxItemSet& );
	virtual void Reset( const SfxItemSet & );
};

}//end of namespace binfilter
#endif // _SVX_LIGHT3D_HXX_

